# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .source_connection_status import SourceConnectionStatus


class SourceConnectionListItem(UniversalBaseModel):
    """
    Simplified schema for source connection list item.

    This is a compact representation containing only core attributes
    directly from the source connection model.
    """

    id: str
    name: str
    description: typing.Optional[str] = None
    short_name: str
    status: SourceConnectionStatus
    created_at: dt.datetime
    modified_at: dt.datetime
    sync_id: str
    collection: str
    white_label_id: typing.Optional[str] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
